﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Shapes;
using System.Windows.Threading;

namespace MTCMSNETDemo
{
    /// <summary>
    /// Interaction logic for PINWindow.xaml
    /// </summary>
    public partial class PINWindow : Window
    {
        private DispatcherTimer m_dismissTimer;
        private EventHandler m_dissmissTimerHandler;
        private string m_value;
        private bool m_timedout;

        public PINWindow()
        {
            InitializeComponent();

            m_value = "";
            m_timedout = false;
        }

        public void init(long timeout)
        {
            WindowStartupLocation = WindowStartupLocation.CenterOwner;

            m_dismissTimer = new DispatcherTimer();
            m_dismissTimer.Interval = new TimeSpan(0, 0, 0, 0, (int)timeout);
            m_dissmissTimerHandler = new EventHandler(dismissTimerTick);
            m_dismissTimer.Tick += m_dissmissTimerHandler;
            m_dismissTimer.Start();

            PINBox.Focus();
            Keyboard.Focus(PINBox);
        }

        public string getValue()
        {
            return m_value;
        }

        public bool isTimedout()
        {
            return m_timedout;
        }

        private void dismissTimerTick(object sender, EventArgs e)
        {
            try
            {
                m_dismissTimer.Tick -= m_dissmissTimerHandler;

                this.DialogResult = false;

                m_timedout = true;
                m_value = "";

                this.Close();
            }
            catch (Exception)
            {
            }
        }

        protected void CancelButtonClick(object sender, RoutedEventArgs e)
        {
            try
            {
                this.DialogResult = false;

                m_value = "";

                this.Close();
            }
            catch (Exception)
            {
            }
        }

        protected void ClearButtonClick(object sender, RoutedEventArgs e)
        {
            try
            {
                PINBox.Clear();
                PINBox.Focus();
                Keyboard.Focus(PINBox);
            }
            catch (Exception)
            {
            }
        }

        protected void EnterButtonClick(object sender, RoutedEventArgs e)
        {
            try
            {
                this.DialogResult = true;

                try
                {
                    m_value = PINBox.Password;
                }
                catch (Exception)
                {
                    m_value = "";
                }

                this.Close();
            }
            catch (Exception)
            {
            }
        }


    }
}
